



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>为你的PHP程序选择合适的密码库（初稿）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">为你的PHP程序选择合适的密码库（初稿）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-07 10:08:56 </span>
						</div>
										<div class="post-content">
											
		<p>如果本文中的术语让你感到疑惑，请先参阅<a href="httpsparagonie.comblog201508you-wouldnt-base64-a-password-cryptography-decoded" rel="external nofollow noreferrer">密码学术语及概念</a>一文。</p>
<p>密码学不是魔术。加密一个应用程序并不能保证它在袭击下的安全（特别是在你<a href="httpsparagonie.comblog201505using-encryption-and-authentication-correctly" rel="external nofollow noreferrer">没有设置验证密文</a>的情况下）。但如果出于商业需求你要确保程序的安全，传统做法会建议你最好<a href="httpwww.cryptofails.compost75204435608write-crypto-code-dont-publish-it" rel="external nofollow noreferrer">不要尝试设计你自己的密码</a>。你应该使用已有的密码库。</p>
<p>好了，以上我都了解了。那么我应该用哪个PHP密码库呢？</p>
<p>这取决于你的实际需求。让我们来看一下一些好的选择。（我们不会提及任何糟糕的密码库的。）</p>
<h2>安全的PHP密码库建议</h2>
<p>下面是一个安全信任度较高的可部署在生产环境中的PHP密码库清单。本清单基于以下三项标准进行优先排序。</p>
<ol><li>若正确使用，此密码库的安全程度如何？</li>
<li>风险行为的困难度如何？</li>
<li>一个非密码破译者最大限度使用之的简易度如何？</li></ol>
<h3><a href="httpsgithub.comparagoniehalite" rel="external nofollow noreferrer">Halite</a> – 来自 Paragon Initiative Enterprises</h3>
<p>我们推荐此密码库不仅是因为它是我们自写的，首推它是因为你可以通过简单直观的接口获取<a href="httpsparagonie.comblog201509how-to-safely-implement-cryptography-in-any-application" rel="external nofollow noreferrer">使用libsodium</a>的全部安全保护。这是一款免费软件，并且源码是可以直接获取的。</p>
<h4>使用Halite的好处</h4>
<p>• 主线</p>
<ul><li>对称密钥认证加密</li>
<li>对称密钥认证（例如：API 消息）</li>
<li>非对称密钥认证加密</li>
<li>非对称密钥匿名加密</li>
<li>非对称密钥数字签名</li></ul>
<p>• 全文件加密（见：所有主线特征）</p>
<p>• 加密cookies</p>
<p>• 密码存储</p>
<p>• 你不需要知道现时值是什么，你也不需要特别关注认证加密。Halite会帮你做好一切。</p>
<p>我们创建<a href="httpsgithub.comparagoniehalite" rel="external nofollow noreferrer">Halite</a>以供PHP开发者通过一个更简单的接口获取<a href="httpspecl.php.netpackagelibsodium" rel="external nofollow noreferrer">libsodium拓展</a>的所有安全性优势。查看<a href="httpsgithub.comparagoniehalitetreemasterdoc" rel="external nofollow noreferrer">Halite的相关文件</a>就能知道它的使用是多么简便。（尽管 API 是固定的，Halite帮助文件依然是不完善的。然而它已经足以涵盖入门级的内容。）</p>
<p>唯一的缺陷是你必须<a href="httpsparagonie.combookpecl-libsodiumread00-intro.md%20-%20installing-libsodium" rel="external nofollow noreferrer">安装PHP的libsodium扩展包</a>才能使用Halite。因此对于很多项目来说，Halite方式是行不通的。</p>
<h4>安装指南：</h4>
<ol><li><a href="httpsparagonie.combookpecl-libsodiumread00-intro.md%20-%20installing-libsodium" rel="external nofollow noreferrer">安装PHP的libsodium扩展包</a></li>
<li>需要 paragoniehalite`</li></ol>
<p>很显然，如果你不喜欢我们对于Halite所做的决策，那么可以考虑直接<a href="httpsparagonie.comblog201509how-to-safely-implement-cryptography-in-any-application" rel="external nofollow noreferrer">使用libsodium</a>。</p>
<h4>使用libsodium的优势</h4>
<p>• 对称密钥加密认证（同：AEAD）</p>
<p>• 对称密钥认证</p>
<p>• 非对称密钥认证加密</p>
<p>• 非对称密钥匿名加密</p>
<p>• 非对称密钥数字签名</p>
<p>• 加密哈希函数</p>
<p>• 密码存储</p>
<p>• 瑞士军刀式的密码学原语（比如：基于Curve25519的Diffe-Hellman密钥交换协议的椭圆曲线）</p>
<p>• 在PHP中的内存清除（补零）能力</p>
<p>• <a href="httpsdownload.libsodium.orgdoc" rel="external nofollow noreferrer">还有好多</a></p>
<p>请向<a href="https00f.net" rel="external nofollow noreferrer">Frank Denis</a>以及创作了<a href="httpnacl.cr.yp.to" rel="external nofollow noreferrer">NaCl</a>（libsodium由此分生）的小组致敬，因为libsodium一直是世界上最可靠的，跨平台的密码学库。</p>
<h4>安装指南</h4>
<p>请参阅<a href="httpsparagonie.combookpecl-libsodiumread00-intro.md%20-%20installing-libsodium" rel="external nofollow noreferrer">相关文件</a>。</p>
<h3><a href="httpsgithub.comdefusephp-encryption" rel="external nofollow noreferrer">PHP Encryption</a> – 来自 Defuse Security</h3>
<p>如果你不能从PECL（也就是永远不能安装libsodium）安装PHP拓展包，这个密码库应该是你的备用选择。通常情况下，不论你的框架提供了什么方案，你都应该优先考虑它，因为我们的安全小组经常能发现PHP框架提供的对称密钥加密功能的缺陷。</p>
<h4>使用Defuse Security 的 PHP密码库的优势：</h4>
<p>• Symmetric-key authenticated encryption</p>
<p>• 对称密钥认证加密</p>
<p>它解决了大多数人都会遇到的一个问题（并且解决得非常棒）。该密码库的第二版（即将发布！）将同样涵盖全文件加密，但是由于它还未发布，因此我们还不能以此为加分项。</p>
<h4><a href="httpsgithub.comphpseclibphpseclib" rel="external nofollow noreferrer">Phpseclib</a> - Jim Wigginton, et al. (仅对 RSA 而言)</h4>
<p>如果你一定要安装对称密钥加密，请使用上述的Defuse的密码库。Defuse Security的密码库为你提供了认证加密，而phpseclib的AES实施并不会验证密文。因此如果你使用它，你对选择密文攻击的抵抗力将十分脆弱。（他们的交互文件在ECB模式下同样出错严重，是我们提过的<a href="httpsblog.filippo.iothe-ecb-penguin" rel="external nofollow noreferrer">最坏分组密码模式</a>。）</p>
<p>尽管phpseclib为通用对称秘钥加密方式提供的 API 等级过低，使得我们不愿向缺乏密码学背景的PHP开发者在这种使用方式下推荐它，但是它相对extopenssl而言提供了一种更好的非对称秘钥加密方式。</p>
<p>如果你坚持必须使用非对称秘钥加密方式（公共秘钥加密，电子签名）并且出于各种原因无法使用libsodium，那么你就应该考虑安装phpseclib，并且严格遵循Colin Percival提出的<a href="httpwww.daemonology.netblog2009-06-11-cryptographic-right-answers.html" rel="external nofollow noreferrer">密码算法的正确解答</a>。</p>
<h4>特别注意</h4>
<ul><li>RSA加密算法：<a href="httpphpseclib.sourceforge.netrsaexamples.html#encrypt,enc1" rel="external nofollow noreferrer">RSA-OAEP</a>（最优不对称加密填充），首先考虑<br />
$rsa-setMGFHash('sha256')</li>
<li>RSA<br />
签名加密：<a href="httpphpseclib.sourceforge.netrsaexamples.html#sign,sign1" rel="external nofollow noreferrer">RSA-PSS</a>(probabilistic<br />
signature scheme),再次明确指定使用MGF1+SHA256</li></ul>
<p>如果你刚好是一位密码学专家，那你可以忽略我们的警示信息，使用phpseclib提供的对称秘钥加密方式。但是对大多数非密码学专家的编程者来说，请最好不要忽略我们的提示。</p>
<h4>使用PHPSecLib的优势：</h4>
<ul><li>对称秘钥认证（通过HMAC秘钥，PHP同样提供）</li>
<li>非对称秘钥匿名加密（RSA）</li>
<li>非对称秘钥电子签名方式（RSA）</li></ul>
<h3>更新内容 (2015-11-19) <a href="httpsgithub.comparagonieEasyRSA" rel="external nofollow noreferrer">Easy RSA</a></h3>
<p>在本篇博客发布以后，我们又针对建议开发了插入式安装包，EasyRSA。EasyRSA是一种方向确定且默认安全设置的phpseclib使用。</p>
<h4>EasyRSA加密过程</h4>
<p>问题：使用RSA加密一段超大字符串，即使RSA本身也不支持加密超大字符串数据。</p>
<p>原始解决方案是将你输入的字符串切分分块并单独分别加密。然而这和<a href="httpsfilippo.iothe-ecb-penguin" rel="external nofollow noreferrer">可怕的电码本（ECB）模式</a>十分相似。同样的：它的处理进程也十分缓慢。这是个非常糟糕的解决方案。</p>
<h4>我们的解决方案</h4>
<ul><li>生成临时秘钥</li>
<li><p>使用<a href="httpsgithub.comdefusephp-encryption" rel="external nofollow noreferrer">Defuse Security的PHP对称秘钥加密密码库</a>加密您的消息</p></li>
<li>使用已有RSA公共秘钥加密临时秘钥（一种对padding oracles攻击方式抵抗效果良好的方式）</li>
<li>基于64位编码，并且使用版本标记前缀来连接密文</li>
<li><p>附加第四步中的校验和（截取的哈希SHA256加密算法）来增强传输存储错误检测能力。</p></li></ul>
<h4>要解密一段消息</h4>
<ol><li>验证检验和和版本标记</li>
<li>使用正确RSA私钥来解密临时秘钥</li>
<li>使用上一步获取的解密秘钥来获取明文</li></ol>
<p>EasyRSA只使用RSAES-OAEP + MGF1-SHA256 with e = 65537来进行公钥加密，已知此种加密方式对任何padding oracle攻击都是有良好抵抗力的。</p>
<h4>EasyRSA 签名方式</h4>
<p>RSA签名方式是相对直接的：使用RSASS-PSS + MGF1-SHA256 with e = 65537来计算RSA签名，然后校验它是否设定为仅接受此种签名。</p>
<p>但是认真讲，如果你真的想为你的PHP程序找到一种确保安全的加密方式，请尝试寻找能使用libsodium的方式。我们正推动<a href="httpsparagonie.comblog201509state-cryptography-in-php" rel="external nofollow noreferrer">使libsodium成为PHP7.1中的核心拓展包</a>，因此希望它的使用能够在将来同“更新新版PHP”一样简单。</p>
<h2>关于我们提供的PHP加密库建议</h2>
<h3>那其他密码库呢？</h3>
<p>任何未在上文提及的密码库的落选原因都可以由以下三条可能原因解释：</p>
<ol><li>我们审核了该密码库，但是凭心而论并不足以让我们进行推荐。（有可能我们已经告知创作者其密码库存在缺陷，以便他们加以改进。）</li>
<li>密码库使用范围太窄（比如Crypt GPG），或者尽管安全，它和加密的广泛使用情况并不相关。</li>
<li>我们太忙了，还没审核该密码库。（我们可能还不知道有这个密码库的存在。）</li></ol>
<p>如果你对我们认定<a href="httpsparagonie.comsecurity" rel="external nofollow noreferrer">有缺陷的密码库</a>感兴趣，请查看安全建议页以获取更多信息。</p>
<h3>在PHP中，我们应该使用何种方式加密密码？</h3>
<p>你不需要加密密码，你只需要<a href="httpcodahale.comhow-to-safely-store-a-password" rel="external nofollow noreferrer">用合适的密码散列算法</a>（哈希密码算法）来<a href="httpsparagonie.comblog201508you-wouldnt-base64-a-password-cryptography-decoded" rel="external nofollow noreferrer">杂乱密码</a>。当前的最佳密码库之一是PHP内建的： password_hash() andpassword_verify()。这种散列算法对99%的编程者或企业来说都是稳定有效的。这个算法就是这么棒。</p>
<p>然而，如果你将数据库中的密码存储在你网页应用的不同服务器中，你可以通过加密散列（而不是加密密码本身）来减轻密码入侵风险。要使用这种方式，请查看<a href="httpsgithub.comparagoniehaliteblobmasterdocClassesPassword.md" rel="external nofollow noreferrer">Halite密码课程</a>。</p>
<h2>重要的安全建议免责声明</h2>
<p>尽管我们雇佣了一些PHP开发安全的行业顶尖专家（并且我们精于应用密码学），在不了解你的特定项目要求和风险模型的前提下，他们在写作这篇向导时并不能指引你选取最符合需求的解决方案。</p>
<p>因此如果，比如，你需要使用非对称加密算法，还执意选择使用Defuse Security的对称加密密码库，请不要说“是Paragon Initiative Enterprises让我这么干的！”</p>
<p>如果你想根据自己的特定项目获得我们的安全建议，请考虑<a href="httpsparagonie.comcontact" rel="external nofollow noreferrer">雇用我们进行安全咨询服务</a>。</p>
<p>或者用法律术语说：此文信息不提供任何担保，使用风险自负。</p>
<p>原文地址：<a href="https://paragonie.com/blog/2015/11/choosing-right-cryptography-library-for-your-php-project-guide" rel="external nofollow noreferrer">Choosing the Right Cryptography Library for your PHP Project: A Guide</a></p>
<p><strong>本文系 <a href="http://www.oneapm.com/?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E4%B8%BA%E4%BD%A0%E7%9A%84PHP%E7%A8%8B%E5%BA%8F%E9%80%89%E6%8B%A9%E5%90%88%E9%80%82%E7%9A%84%E5%AF%86%E7%A0%81%E5%BA%93&amp;utm_campaign=AiPHPArti&amp;from=jsclgcmbmg" rel="external nofollow noreferrer">OneAPM</a> 工程师编译整理。OneAPM 是<a href="http://www.oneapm.com/" rel="external nofollow noreferrer">应用性能管理</a>领域的新兴领军企业，能帮助企业用户和开发者轻松实现：缓慢的程序代码和 SQL 语句的实时抓取。想阅读更多技术文章，请访问 <a href="http://news.oneapm.com/?utm_source=Community&amp;utm_medium=Article&amp;utm_term=%E4%B8%BA%E4%BD%A0%E7%9A%84PHP%E7%A8%8B%E5%BA%8F%E9%80%89%E6%8B%A9%E5%90%88%E9%80%82%E7%9A%84%E5%AF%86%E7%A0%81%E5%BA%93&amp;utm_campaign=AiPHPArti&amp;from=jsclgcmbmg" rel="external nofollow noreferrer">OneAPM 官方博客</a>。</strong><br />
<strong>本文转自 <a href="http://news.oneapm.com/" rel="external nofollow noreferrer">OneAPM 官方博客</a></strong></p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8e64eq1.html">Python标准模块--asyncio</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ey1oz9.html">postgresql中的CUBE函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1jj4zq.html">List去重复（不是最简单，但绝对是最易理解）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql2g718.html">【leetcode】Reverse Words in a String&lpar;hard&rpar;&star;</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwm0kz8.html">ASP&period;NET 成功执行Update 的 ExecuteNonQuery&lpar;&rpar; 返回值大于0，但是查看数据库却没有改变</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmpj3z9.html">【MariaDB】MariaDB编译参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zy5w59.html">hihocoder 1038 01背包</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o4rwj9.html">asp&period;net&plus;MVC--1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdy44y8.html">&lbrack;RxJS&rsqb; Transformation operator&colon; bufferToggle&comma; bufferWhen</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zpw459.html">android教学大纲</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zdmmj9.html">mysql 左连接 右连接 内链接</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jynwo8.html">使用SuperSocket打造逾10万长连接的Socket服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k61409.html">【转】Sentry--错误日志收集</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15yweq.html">mysql 安装问题一：由于找不到MSVCR120&period;dll&comma;无法继续执行代码&period;重新安装程序可能会解决此问题。</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwjgvq.html">C&plus;&plus;程序设计方法2：基本语法2</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1k4v9.html">mysql 设置用户并授权</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e740k9.html">Freemarker简单用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kg2mwq.html">react组件（react-grid-gallery）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp73ed9.html">Dynamics 365Online  查询Web Api的请求WebUri</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p5z43q.html">javascript 中 IE与FF的不同之处及其兼容写法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1kv559.html">Sqlserver中关于锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v4p1o8.html">MSSQL Server 导入&sol;导出到远程服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmzzj49.html">iOS开发&mdash;&mdash;开发者官网注册新设备</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z16eo39.html">java新手笔记33 多线程、客户端、服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0vxl0q.html">new失败判断</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ok32m19.html">linux端口与进程命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zy2l09.html">仿360手机卫士界面效果android版源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v4n1n8.html">《编写高质量代码-Web前端开发修改之道》笔记--第二章 团队合作</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x3r7n9.html">Laravel Homestead安装教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd6352q.html">从 Typecho 自定义字段的调用代码看去</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
